<?php
// +-----------------------------------------------------------------------+
// | Dynamic Recent Period - a Piwigo Plugin                               |
// | Copyright (C) 2007-2011 Ruben ARNAUD - rub@piwigo.org                 |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH'))
{
  die('Hacking attempt!');
}

// in order to prevent of system witch set array value not empty
// when array is not set
// pb with $filter
//add_event_handler('user_init', 'dynareceperio_user_init');
add_event_handler('init', 'dynareceperio_user_init');

function dynareceperio_user_init()
{
  global $conf, $user;

  if 
    (
      $conf['dynareceperio']['force']
      or
      (get_default_user_value('recent_period', $user['recent_period']) === $user['recent_period'])
    )
  {
    $query = '
select
  Max(D) D
from
  (
    select
      D
    from
      (
        select
          DATEDIFF(CURRENT_DATE, date_available) D
        from
          '.IMAGES_TABLE.' INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON id=image_id
      '.get_sql_condition_FandF
          (
            array
              (
                'forbidden_categories' => 'ic.category_id',
                'visible_categories' => 'ic.category_id',
                'visible_images' => 'ic.image_id'
              ),
            'WHERE',
              true
          ).'
      ) as ListDate
    where
      D >= 0
    group by D
    order by D asc
    limit 0,'.$conf['dynareceperio']['day_number'].'
  ) as MaxD
;';

    $result = pwg_query($query);
    if (list($period) = mysql_fetch_array($result))
    {
      $user['recent_period'] =
        max($period, 
          get_default_user_value('recent_period', $user['recent_period']));
    }
  }

  return;
}

?>
